--- hotspot/src/share/vm/gc_implementation/g1/g1SATBCardTableModRefBS.hpp	2018-06-10 02:13:33.917339226 +0200
+++ hotspot/src/share/vm/gc_implementation/g1/g1SATBCardTableModRefBS.new.hpp	2018-06-10 02:27:34.453336342 +0200
@@ -85,7 +85,17 @@
     guarantee(false, "Not needed");
   }
 
-  template <class T> void write_ref_array_pre_work(T* dst, int count);
+  template <class T> void
+  write_ref_array_pre_work(T* dst, int count) {
+    if (!JavaThread::satb_mark_queue_set().is_active()) return;
+    T* elem_ptr = dst;
+    for (int i = 0; i < count; i++, elem_ptr++) {
+      T heap_oop = oopDesc::load_heap_oop(elem_ptr);
+      if (!oopDesc::is_null(heap_oop)) {
+        enqueue(oopDesc::decode_heap_oop_not_null(heap_oop));
+      }
+    }
+  }
   virtual void write_ref_array_pre(oop* dst, int count, bool dest_uninitialized) {
     if (!dest_uninitialized) {
       write_ref_array_pre_work(dst, count);
